package p1;
//@JPLAS test
 import static org.junit.Assert.assertEquals;
 
 import java.io.ByteArrayOutputStream;
 import java.io.PrintStream;
 import java.lang.reflect.Field;
 import java.lang.reflect.Method;
 import java.util.ArrayList;
 import java.util.Iterator;
 import java.util.List;
 import org.junit.Test;

import report.Report;
 
 public class ArrayListImpTest {
 	@Test
 	public void variablesNameTest() throws NoSuchFieldException, SecurityException {
 		// construct an object
 		ArrayListImp obj = new ArrayListImp();
 		
 		// check the variable name
 		Field f1 = obj.getClass().getDeclaredField("list");// variable 1
 		Field f2 = obj.getClass().getDeclaredField("itr");// variable 2
 		
 		//check the number of variables in author class. 
 		Field[] f=obj.getClass().getDeclaredFields();
 		assertEquals(2, f.length);
 		
 		/*// check the modifier name
 		assertEquals(f1.getModifiers(), Modifier.PRIVATE);
 		assertEquals(f2.getModifiers(), Modifier.PRIVATE);*/
 		
 		//check data type for each variable
 		assertEquals(f1.getType(),List.class);
 		assertEquals(f2.getType(),Iterator.class);
 	}
 	
 	@Test
 	public void methodsNameTest() throws NoSuchMethodException, SecurityException {
 		// construct an object
 		ArrayListImp obj = new ArrayListImp();
 		
 		//check the number of variables in author class. 
 		Method[] m=obj.getClass().getDeclaredMethods();
 		assertEquals(4, m.length);
 		
 		//check method name
 		Method m1 = obj.getClass().getDeclaredMethod("addData", (Class[])null);//method 1
 		Method m2 = obj.getClass().getDeclaredMethod("swapData",(Class[])null); //method 2
 		Method m3 = obj.getClass().getDeclaredMethod("removeData",(Class[])null);//method 3
 		Method m4 = obj.getClass().getDeclaredMethod("showInfo",(Class[])null);//method 4
 		
 		//check data type for each Method
         assertEquals(List.class, m1.getReturnType());
         assertEquals(List.class, m2.getReturnType());
         assertEquals(List.class, m3.getReturnType());
         assertEquals(void.class, m4.getReturnType());
 	}
 	
 	@Test
 	public void test2() {
 		// construct an object
 		ArrayListImp obj = new ArrayListImp();
 		List<String> list = obj.addData();
 		assertEquals(5, list.size());
 		assertEquals("Red",list.get(0));
 		assertEquals("Green",list.get(1));
 		assertEquals("Blue",list.get(2));
 		assertEquals("Black",list.get(3));
 		assertEquals("Orange",list.get(4));
 	}
 	
 	@Test
 	public void test3() {
 		// construct an object
 		ArrayListImp obj = new ArrayListImp();
 		List<String> list = obj.addData();
 		obj.swapData();
 		assertEquals(5, list.size());
 		assertEquals("Blue",list.get(0));
 		assertEquals("Red",list.get(2));
 	}
 	
 	@Test
 	public void test4() {
 		// construct an object
 		ArrayListImp obj = new ArrayListImp();
 		List<String> list = obj.addData();
 		obj.removeData();
 		assertEquals(3, list.size());
 		assertEquals("Green",list.get(0));
 		assertEquals("Black",list.get(1));
 		assertEquals("Orange",list.get(2));
 		}
 	
 	@Test
 	public void test5() {
 		
 		// construct an object
 		ArrayListImp obj = new ArrayListImp();
 		List<String> list = obj.addData();
 		obj.swapData();
 		obj.removeData();
 		ByteArrayOutputStream baos = new ByteArrayOutputStream(1024);
 		PrintStream s = System.out;
 		PrintStream st = new PrintStream(baos);
 		System.setOut(st);
 		obj.showInfo();
 		System.setOut(s);
 		assertEquals("Green Black Orange", baos.toString().trim());
 		
 	}
 	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}
 }
 
 

