package p2;
//@JPLAS test
 import static org.junit.Assert.assertEquals;
 import java.lang.reflect.Field;
 import java.lang.reflect.Method;
 import java.util.List;
 
 import org.junit.Test;

import report.Report;
 
 /*
  * LinkedLink example
  */
 public class LinkedListDemoTest {
 	@Test
 	public void variablesNameTest() throws NoSuchFieldException, SecurityException {
 		// construct an object
 		LinkedListDemo obj = new LinkedListDemo();
 
 		// check the variable name
 		Field f1 = obj.getClass().getDeclaredField("list");// variable 1
 
 		// check the number of variables in author class.
 		Field[] f = obj.getClass().getDeclaredFields();
 		assertEquals(1, f.length);
 
 		// check data type for each variable
 		assertEquals(f1.getType(), List.class);
 	}
 
 	@Test
 	public void methodsNameTest() throws NoSuchMethodException, SecurityException {
 		// construct an object
 		LinkedListDemo obj = new LinkedListDemo();
 
 		// check the number of methods in author class.
 		Method[] m = obj.getClass().getDeclaredMethods();
 		assertEquals(4, m.length);
 
 		// check method name
 		Method m1 = obj.getClass().getDeclaredMethod("addData", (Class[])null);// method
 																		// 1
 		Method m2 = obj.getClass().getDeclaredMethod("insertData", (Class[])null);// method
 																			// 2
 		Method m3 = obj.getClass().getDeclaredMethod("removeData", (Class[])null);// method
 																			// 3
 		Method m4 = obj.getClass().getDeclaredMethod("showData", (Class[])null);// method
 																		// 4
 
 		// check data type for each Method
 		assertEquals(List.class, m1.getReturnType());
 		assertEquals(List.class, m2.getReturnType());
 		assertEquals(List.class, m3.getReturnType());
 		assertEquals(Object.class, m4.getReturnType());
 	}
 
 	@Test
 	public void test1() {
 		// construct an object
 		LinkedListDemo obj = new LinkedListDemo();
 		// add the data to the list
 		List<String> list = obj.addData();
 		// check the data in the list
 		assertEquals(3, list.size());
 		assertEquals("America", list.get(0));
 		assertEquals("Canada", list.get(1));
 		assertEquals("France", list.get(2));
 	}
 
 	@Test
 	public void test2() {
 		// construct an object
 		LinkedListDemo obj = new LinkedListDemo();
 		// add the data to the list
 		List<String> list = obj.addData();
 		// check the data in the list
 		obj.insertData();
 		assertEquals(4, list.size());
 		assertEquals("Russia", list.get(0));
 		assertEquals("America", list.get(1));
 		assertEquals("Canada", list.get(2));
 		assertEquals("France", list.get(3));
 	}
 
 	@Test
 	public void test3() {
 		// construct an object
 		LinkedListDemo obj = new LinkedListDemo();
 		// add data to the list
 		List<String> list = obj.addData();
 		// check the data in the list
 		obj.insertData();
 		// remove data from the list
 		obj.removeData();
 		// check the data in the list
 		assertEquals(3, list.size());
 		assertEquals("Russia", list.get(0));
 		assertEquals("America", list.get(1));
 		assertEquals("France", list.get(2));
 	}
 
 	@Test
 	public void test4() {
 		// construct an object
 		LinkedListDemo obj = new LinkedListDemo();
 		// add data to the list
 		List<String> list = obj.addData();
 		// check the data in the list
 		obj.insertData();
 		// remove data from the list
 		obj.removeData();
 		// check the show data method
 		assertEquals("Index of America is " + 1, obj.showData());
 	}
 	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}
 }
 
//@JPLAS statement
// Before you answer the LinkedListDemoTest, you should study about <a href="index.html?docs/collecttionsInfoDoc.html#list"> List </a>
