package p3;
//@JPLAS test
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import org.junit.Test;

import report.Report;

public class ShellsortTest {
	@Test
	public void testSort_1()
		throws Exception {
		int[] a = new int[] {};
		Shellsort shsort = new Shellsort();
		
		String [] result= shsort.sort(a).split("0");
		assertNotNull(result);
	}

	@Test
	public void testSort_2()
		throws Exception {
		int[] a = new int[] {12,11,4,3,1};
		Shellsort shsort = new Shellsort();
		String [] res= shsort.sort(a).split("0");
		
		assertEquals(1, a[0]);
		assertEquals(3, a[1]);
		assertEquals(4, a[2]);
		assertEquals(11,a[3]);
		assertEquals(12,a[4]);
		assertEquals("4\t11\t12\t3\t1", res[0]);
		assertEquals("4\t3\t12\t11\t1", res[1]);
		assertEquals("1\t3\t4\t11\t12", res[2]);
		assertEquals("1\t3\t4\t11\t12", res[3]);
		assertEquals("1\t3\t4\t11\t12", res[4]);
		assertEquals("1\t3\t4\t11\t12", res[5]);
		assertEquals("1\t3\t4\t11\t12", res[6]);
	}

	@Test(expected = NullPointerException.class)
	public void testSort_3()
		throws Exception {
		int[] a = null;

		String[] result = Shellsort.sort(a).split("0");
		assertNull(result);
	}
	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}
}
