package p4;
//@JPLAS test
 import static org.junit.Assert.assertEquals;
 
 import java.io.ByteArrayOutputStream;
 import java.io.PrintStream;
 import java.lang.reflect.Field;
 import java.lang.reflect.Method;
 import java.util.HashMap;
 import java.util.List;
 import org.junit.Test;

import report.Report;
 
 public class HashMapDemoTest {
 	@Test
 	public void variablesNameTest() throws NoSuchFieldException, SecurityException {
 		// construct an object
 		HashMapDemo obj = new HashMapDemo();
 		
 		// check the variable name
 		Field f1 = obj.getClass().getDeclaredField("hmap");// variable 1
 		
 		
 		//check the number of variables in author class. 
 		Field[] f=obj.getClass().getDeclaredFields();
 		assertEquals(1, f.length);
 		
 		/*// check the modifier name
 		assertEquals(f1.getModifiers(), Modifier.PRIVATE);
 		*/
 		
 		//check data type for each variable
 		assertEquals(f1.getType(),HashMap.class);
 	}
 	
 	@Test
 	public void methodsNameTest() throws NoSuchMethodException, SecurityException {
 		// construct an object
 		HashMapDemo obj = new HashMapDemo();
 		
 		//check the number of variables in author class. 
 		Method[] m=obj.getClass().getDeclaredMethods();
 		assertEquals(3, m.length);
 		
 		//check method name
 		Method m1 = obj.getClass().getDeclaredMethod("putData", (Class[])null);//method 1
 		Method m2 = obj.getClass().getDeclaredMethod("removeData",(Class[])null); //method 2
 		Method m3 = obj.getClass().getDeclaredMethod("displayData",(Class[])null);//method 3
 		
 		//check data type for each Method
         assertEquals(HashMap.class, m1.getReturnType());
         assertEquals(HashMap.class, m2.getReturnType());
         assertEquals(void.class, m3.getReturnType());
 	}
 	
 	@Test
 	public void test2() {
 		// construct an object
 		HashMapDemo obj = new HashMapDemo();
 		HashMap<Integer, String> hmap = obj.putData();
 		
 		// check elements in hashmap
 		assertEquals(5,hmap.size());
 		assertEquals("Coconut", hmap.get(1));
 		assertEquals("Stawberry", hmap.get(2));
 		assertEquals("Apple", hmap.get(3));
 		assertEquals("Mango", hmap.get(4));
 		assertEquals("Orange", hmap.get(5));			
 	}
 	
 	@Test
 	public void test3() {
 		// construct an object
 		HashMapDemo obj = new HashMapDemo();
 		HashMap<Integer, String> hmap = obj.putData();
 		
 		// remove element function in the hmap
 		obj.removeData();
 		
 		// check elements in hashmap
 		assertEquals(4,hmap.size());
 		assertEquals("Coconut", hmap.get(1));
 		assertEquals("Stawberry", hmap.get(2));
 		assertEquals("Mango", hmap.get(4));
 		assertEquals("Orange", hmap.get(5));
 	}
 	
 	@Test
 	public void test4() {
 		// construct an object
 		HashMapDemo obj = new HashMapDemo();
 		HashMap<Integer, String> hmap = obj.putData();
 		obj.removeData();
 		ByteArrayOutputStream baos = new ByteArrayOutputStream(1024);
 		PrintStream s = System.out;
 		PrintStream st = new PrintStream(baos);
 		System.setOut(st);
 		obj.displayData();
 		System.setOut(s);
 		assertEquals("1=Coconut 2=Stawberry 4=Mango 5=Orange", baos.toString().trim());	
 	}
 	
 	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}
 }
 
 //@JPLAS statement
 //Before you answer this test code, you can study about  <a href="index.html?docs/collecttionsInfoDoc.html#map"> Map </a>
