package p5;
//@JPLAS test
 import static org.junit.Assert.assertEquals;
 
 import java.io.ByteArrayOutputStream;
 import java.io.PrintStream;
 import java.lang.reflect.Constructor;
 import java.lang.reflect.Field;
 import java.lang.reflect.Method;
 import java.lang.reflect.Modifier;
 import java.util.Iterator;
 import java.util.TreeSet;
 
 import org.junit.Test;

import report.Report;
 
 public class TreeSetDemoTest {
 	@Test
 	public void variablesNameTest() throws NoSuchFieldException, SecurityException {
 		// construct an object
 		TreeSetDemo obj = new TreeSetDemo();
 		
 		// check the variable name
 		Field f1 = obj.getClass().getDeclaredField("tset");// variable 1
 		Field f2 = obj.getClass().getDeclaredField("iterator");// variable 2
 		
 		//check the number of variables in author class. 
 		Field[] f=obj.getClass().getDeclaredFields();
 		assertEquals(2, f.length);
 		
 		/*// check the modifier name
 		assertEquals(f1.getModifiers(), Modifier.PRIVATE);
 		assertEquals(f2.getModifiers(), Modifier.PRIVATE);*/
 		
 		//check data type for each variable
 		assertEquals(f1.getType(),TreeSet.class);
 		assertEquals(f2.getType(),Iterator.class);
 	}
 	
 	@Test
 	public void methodsNameTest() throws NoSuchMethodException, SecurityException {
 		// construct an object
 		TreeSetDemo obj = new TreeSetDemo();
 		
 		//check the number of variables in author class. 
 		Method[] m=obj.getClass().getDeclaredMethods();
 		assertEquals(3, m.length);
 		
 		//check method name
 		Method m1 = obj.getClass().getDeclaredMethod("addData", (Class[])null);//method 1
 		Method m2 = obj.getClass().getDeclaredMethod("removeData",(Class[])null); //method 2
 		Method m3 = obj.getClass().getDeclaredMethod("displayData",(Class[])null);//method 3
 		
 		//check data type for each Method
         assertEquals(TreeSet.class, m1.getReturnType());
         assertEquals(TreeSet.class, m2.getReturnType());
         assertEquals(TreeSet.class, m3.getReturnType());
 	}
 	
 	
 	@Test
 	public void test2() {
 		TreeSetDemo obj = new TreeSetDemo();
 		TreeSet<String> tset = obj.addData();
 		for (Object x : tset) { 
 			assertEquals("String".getClass().getName(), x.getClass().getName());
 		}
 		assertEquals(6, tset.size());
 		assertEquals("ABC",tset.first());
 		assertEquals("Test",tset.last());
 	}
 	
 	@Test
 	public void test3() {
 		TreeSetDemo obj = new TreeSetDemo();
 		TreeSet<String> tset = obj.addData();
 		obj.removeData();
 		assertEquals(4, tset.size());
 		assertEquals("ABC",tset.first());
 		assertEquals("String",tset.last());
 	}
 	@Test
 	public void test4() {
 		TreeSetDemo obj = new TreeSetDemo();
 		TreeSet<String> tset = obj.addData();
 		ByteArrayOutputStream baos = new ByteArrayOutputStream(1024);
 		PrintStream s = System.out;
 		PrintStream st = new PrintStream(baos);
 		System.setOut(st);
 		obj.displayData();
 		System.setOut(s);
 		assertEquals("ABC Ink Jack Pen String Test", baos.toString().trim());
 	}
 	@Test
	public void jplasStocker() {
		Report.record(this.getClass().getName());
		
	}
 }
 

//@JPLAS statement
//Before you answer this test code, you can study about  <a href="index.html?docs/collecttionsInfoDoc.html#map">Set </a>
